/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/
%{
#include "extern.h"
#include "head.h"

int se_interfaces_within_interfaces = 0;  /* hack to fix interf within interf */
%}
%token '=' EQ
%token '+' PLUS
%token '-' MINUS
%token '*' TIMES
%token '/' SLASH
%token '(' LP
%token ')' RP
%token ',' COMMA
%token '.' DOT
%token ':' COLON
%token '%' PERCENT
%token '?' QUESTION
%token '$' DOLLAR

%token ALLOCATABLE
%token ALLOCATE
%token AND_OP		".AND."
%token ASSIGN
%token BACKSPACE
%token BINARY_CONSTANT
%token BLOCK_DATA	"BLOCK DATA"
%token CALL
%token CASE
%token CHAR_SELECTOR_COMMA	","
%token CHARACTER
%token CHARACTER_CONSTANT [
D|
]
%token CLOSE
%token COMMON
%token COMPLEX
%token CONCAT_OP	"//"
%token CONTAINS
%token CONTINUE
%token CYCLE
%token DATA
%token DOUBLE_COMPLEX		"DOUBLE COMPLEX"
%token DEALLOCATE
%token DEFINED_UNARY_OP
%token DIMENSION
%token DO
%token DOUBLE_PRECISION		"DOUBLE PRECISION"
%token ELSE
%token ELSE_IF	"ELSE IF"
%token ELSE_WHERE
%token END
%token END_BLOCK_DATA
%token END_DO	"END DO"
%token END_FILE	"ENDFILE"
%token END_FUNCTION
%token END_IF	"END IF"
%token END_INTERFACE
%token END_MODULE	"END MODULE"
%token END_PROGRAM
%token END_SELECT
%token END_SUBROUTINE
%token END_TYPE
%token END_WHERE
%token ENTRY
%token EOS	"\n"
%token EQUIVALENCE
%token EQUIV_OP_F	".NEQV."
%token EQUIV_OP_T	".EQV."
%token EXIT
%token EXTERNAL
%token FORMAT [
D|
]
%token FUNCTION
%token GO_TO	"GO TO"
%token HEX_CONSTANT
%token IF
%token IMPLICIT
%token INCLUDE
%token INQUIRE
%token INTEGER
%token INTEGER_CONSTANT [
D|
]
%token INTENT
%token INTERFACE
%token INTRINSIC
%token LDAC		"(/"
%token LOGICAL
%token LOGICAL_CONSTANT [
D|
]
%token LPEQI	"("
%token LPIMP	"("
%token MODULE
%token NAME [
D|
]
%token NAMELIST
%token NOT_OP		".NOT."
%token NULLIFY
%token OCTAL_CONSTANT
%token OPEN
%token OPTIONAL
%token OR_OP		".OR."
%token PARAMETER
%token PAUSE
%token POINTER
%token POINT_OP		"=>"
%token POINT_TO
%token POWER_OP		"**"
%token PRINT
%token PRIVATE
%token KPROGRAM		"PROGRAM"
%token PUBLIC
%token RDAC		"/)"
%token READ
%token REAL
%token REAL_CONSTANT [
D|
]
%token RECURSIVE
%token REL_OP_EQ	".EQ."
%token REL_OP_GE	".GE."
%token REL_OP_GT	".GT."
%token REL_OP_LE	".LE."
%token REL_OP_LT	".LT."
%token REL_OP_NE	".NE."
%token RETURN
%token REWIND
%token SAVE
%token SELECT
%token SEQUENCE
%token STOP
%token SUBROUTINE
%token KTARGET		"TARGET"
%token TO
%token TYPE
%token USE
%token WHERE
%token WRITE
%token XOR_OP		".XOR."

/* tokens for CMF extensions */

%token ARRAY
%token FORALL

/* ##BEG##, 9/19/91, SHU */
%token DIRBLOCK
%token DIRCYCLIC
%token DIRDECOMPOSE
%token DIRDISTRIBUTE
/* ##END## */

/* ##BEG##, 10/27/91, ZEKI */
%token DIRALIGN
%token DIRWITH

/* tokens for dummys */

%token DUMTOK
%token OP
%token CODE [
D|
]
%token KEY_NAME [
D|
]
%token IGNORE_STMT

%start Program

%%

Program
	: 
	| Program Statement
	{
		int i;
		Node *orig_stmt;

		if (se_interfaces_within_interfaces) {
			if ($2->Statement.Stmt != NN) {
				if ($2->Statement.Stmt->com.type == END_INTERFACE)
					se_interfaces_within_interfaces--;

/*!!! Next is a partial fix, it will not work if type is not decl
      in the FunStmt. */

				if ($2->Statement.Stmt->com.type == FUNCTION_STMT) {
					if (se_EtypeSpec == EN)
						se_EtypeSpec
						= implicit_get ($2->Statement.Stmt->FunctionStmt.Name->com.str);

					install_loc (
					  $2->Statement.Stmt->FunctionStmt.Name->com.str
					, TAB_TYP_ETYPE, se_EtypeSpec);
				}
			}

			goto skip_rest;
		}
		if (flag_pp)
			tree_pp ($2);

		orig_stmt = $2->Statement.Stmt;
		$2 = $$->Program.Statement = parse_pass ($2);
		if (se_is_statement_function_def)
			$2->Statement.fun = order ($2->Statement.Stmt);
		else if (orig_stmt != NN)
			$2->Statement.fun = order (orig_stmt);
		if ($2->Statement.Stmt != NN && $2->Statement.Stmt->def.type != IGNORE_STMT)
			if (!se_in_interface)
				block_add_sta ($2);
		clear_se ();
		if ($2->Statement.Stmt != NN) {
			switch ($2->Statement.Stmt->com.type) {

			case END_STMT:
			case END_FUNCTION_STMT:
			case END_BLOCK_DATA_STMT:
			case END_SUBROUTINE_STMT:
			case END_MODULE_STMT:
			case END_PROGRAM_STMT:
				if (flag_pp) {
					printf ("\n------- after TRANS ---------\n\n");
					tree_pp (program_unit);
					printf ("\n-----------------------------\n\n");
				}
				if (!se_in_interface
				&& (flag_ignore_fatal || error_level < ERR_NOTIMPLEM)
				&& (se_unit_stmt == NN || se_unit_stmt->com.type != MODULE_STMT)
				)  comm_ProgramUnit (program_unit );
             			current_pass = PASS_WRITE;
				proc_end_before_write ();
				if (!se_in_interface
				&& (flag_ignore_fatal || error_level < ERR_NOTIMPLEM)
				&& (se_unit_stmt == NN || se_unit_stmt->com.type != MODULE_STMT)
				) {
					write_ProgramUnit (program_unit);
#ifdef KO
					if (flag_ko)
						ko_add (program_unit);
#endif
				}

#ifdef CHECK
				if (flag_tableshow)
					if (num_yywrap)
						table_show1 ();
#endif

				proc_end_after_write ();
				current_pass = PASS_PARSE;
				$$ = NN;
				break;
			}
		}

		skip_rest:;
	}
	| Program DerivedTypeDef
	{
		f90ni_uddtao ();
	}
	;

/* 2: F O R T R A N   T E R M S   A N D   C O N C E P T S */
/* 206-216, */

Statement [
A| int line; char *file; PtF fun; char* arg; union Node *label, *var;
]
	: INTEGER_CONSTANT Stmt EOS
	{
		int type = $2->com.type;

		if (type == INCLUDE_STMT) {
			fatal ("labels not allowed in INCLUDE statements");
			$$->Statement.Stmt = NN;
			$$->Statement.Error = &Error;
		}

		if (type == FORALL_STMT)
			$2->ForallStmt.statement = $$;

		$$->Statement.line = zzlineno;
		$$->Statement.file = input_filename;

		if (type == FORMAT_STMT) {
			checkx_FormatStmt ($$);
			label_install_format ($1);
		}
		else {
			label_install_def ($1);
		}
	}
	| Stmt EOS
	{
		int type = $1->com.type;
 
		if (type == FORMAT_STMT)
			fatal ("no LABEL in FORMAT statement");

		if (type == INCLUDE_STMT)
			include_add ($1->IncludeStmt.CharacterConstant->com.str);

		$$->Statement.line = zzlineno;
		$$->Statement.file = input_filename;

		if ($1->com.type == FORALL_STMT)
			$1->ForallStmt.statement = $$;
	}
	| EOS
	{
		$$->Statement.line = zzlineno;
		$$->Statement.file = input_filename;
	}
	| error EOS
	{
		$$->Statement.line = zzlineno - 1;
		yyerrok;
	}
	;

Stmt
	: ImplicitStmt
	| ImplicitNoneStmt
	| FormatStmt
	| EntryStmt
	| TypeDeclarationStmt
	| ParameterStmt
	| DataStmt
	| CommonStmt
	| DimensionStmt
	| EquivalenceStmt
	| ExternalStmt
	| AssignementStmt
	| CallStmt
	| CloseStmt
	| ComputedGotoStmt
	| ContinueStmt
	| EndFileStmt
	| BackspaceStmt
	| InquireStmt
	| GotoStmt
	| IfStmt
	| IfThenStmt
	| ElseIfStmt
	| ElseStmt
	| EndIfStmt
	| DoStmt
	| EndDoStmt
	| OpenStmt
	| PrintStmt
	| ReadStmt
	| ReturnStmt
	| RewindStmt
	| StopStmt
	| WriteStmt
	| ArithmeticIfStmt
	| AssignStmt
	| AssignedGotoStmt
	| PauseStmt
	| EndStmt
	| ProgramStmt
	| SubroutineStmt
	| FunctionStmt
	| IntrinsicStmt
	| IntentStmt
	| OptionalStmt
	| AccessStmt
	| SaveStmt
	| AllocatableStmt
	{
		f90ni_pointers ();
	}
	| PointerStmt
	{
		f90ni_pointers ();
	}
	| TargetStmt
	{
		f90ni_pointers ();
	}
	| NamelistStmt
	| AllocateStmt
	{
		f90ni_pointers ();
	}
	| NullifyStmt
	{
		f90ni_pointers ();
	}
	| DeallocateStmt
	{
		f90ni_pointers ();
	}
	| PointerAssignementStmt
	{
		f90ni_pointers ();
	}
	| WhereStmt
	| WhereConstructStmt
	| ElsewhereStmt
	| EndWhereStmt
	| SelectCaseStmt
	| CaseStmt
	| EndSelectStmt
	| ExitStmt
	| CycleStmt
	| EndProgramStmt
	| ModuleStmt
	| EndModuleStmt
	| UseStmt
	| BlockDataStmt
	| EndBlockDataStmt
	| InterfaceStmt
	| EndInterfaceStmt
	| ModuleProcedureStmt
	| EndFunctionStmt
	| EndSubroutineStmt
	| ContainsStmt
	{
		f90ni_internal_procedures ();
	}
	| ForallStmt
	| IncludeStmt
/* ##BEG##, 9/22/91, SHU */
	| DirectiveStmt
/* ##END## */
	;

/* ##BEG##, 9/22/91, SHU */
DirectiveStmt
	: DIRDECOMPOSE DecomposeList
	| DIRDISTRIBUTE DistributeList
        | DIRALIGN  AlignList  DIRWITH AlignSpec
        ;


DecomposeList
	: DecomposeList ',' DecomposeSpec
	| DecomposeSpec
	;
DecomposeSpec
	: NAME '(' SizeList ')'
	;
SizeList
	: SizeList ',' INTEGER_CONSTANT
	| INTEGER_CONSTANT
	;
DistributeList
	: DistributeList ',' DistributeSpec
	| DistributeSpec
	;
DistributeSpec
	: NAME '(' DistList ')'
	;
DistList 
	: DistList ',' DistSpec
	| DistSpec
	;
DistSpec
	: DIRBLOCK
	| DIRCYCLIC
	| ':'
	;
/* ##BEG##, 11/08/1991, ZEKI */
AlignList
	: AlignList ',' AlignSpec
	| AlignSpec
	;
AlignSpec
	: NAME '(' SubscriptList ')'
        | NAME
	;
/*
AlignIndexList 
        : AlignIndexList ',' AlignIndexSubscript
        | AlignIndexSubscript
        ;
AlignIndexSubscript
        : Expr
        | '*'
        ;
*/
/* ##END## */


IncludeStmt
	: INCLUDE CHARACTER_CONSTANT
	;

/* 3: C H A R A C T E R S,   L E X I C A L   T O K E N S   A N D   S O U R C E   F O R M */
/* 305:
   Can only find out LiteralConstants at this level */
/* 306 */

LiteralConstant
	: INTEGER_CONSTANT
	| REAL_CONSTANT
	| ComplexLiteralConstant
	| LOGICAL_CONSTANT
	| BozLiteralConstant
	| CHARACTER_CONSTANT
	;

/* 310 */

IntrinsicOp
	: POWER_OP
	| MultOp
	| AddOp
	| CONCAT_OP
	| RelOp
	| NOT_OP
	| AND_OP
	| OR_OP
	| XOR_OP
	| EquivOp
	;

/* 311 */

DefinedOperator
	: DEFINED_UNARY_OP
	O|{
		f90ni_uddtao ();
	}
	| IntrinsicOp
	;

/* 4: I N T R I N S I C   A N D   D E R I V E D   D A T A   T Y P E S */
/* 407 */

BozLiteralConstant
	: BINARY_CONSTANT
	| OCTAL_CONSTANT
	| HEX_CONSTANT
	;

/* 417. Note that it can also not be literal, maybe check and give error. */

ComplexLiteralConstant
	: '(' Expr ',' Expr ')'
	;

/* 422 */

DerivedTypeDef
	: DerivedTypeStmt EOS
	  OptPrivateSequenceStmtList
	  ComponentDefStmtList
	  EndTypeStmt EOS
	O| {$$ = make (DERIVED_TYPE_DEF);}
	;

OptPrivateSequenceStmtList
	:
	| PrivateSequenceStmtList
	O| {;}
	;

PrivateSequenceStmtList
	: PrivateSequenceStmt EOS
	O| {;}
	| PrivateSequenceStmtList PrivateSequenceStmt EOS
	O| {;}
	;

ComponentDefStmtList
	: ComponentDefStmt EOS
	O| {;}
	| ComponentDefStmtList ComponentDefStmt EOS
	O| {;}
	;

/* 423 */

PrivateSequenceStmt [
N|
]
	: PRIVATE
	| SEQUENCE
	;

/* 424 */

DerivedTypeStmt
	: TYPE ',' AccessSpec OptCC NAME
	O| {$$ = make (DERIVED_TYPE_STMT);}
	| TYPE NAME
	O| {$$ = make (DERIVED_TYPE_STMT);}
	;

/* 425 */

EndTypeStmt
	: END_TYPE
	O| {$$ = make (END_TYPE_STMT);}
	| END_TYPE NAME
	O| {$$ = make (END_TYPE_STMT);}
	;

/* 426 */

ComponentDefStmt
	: TypeSpec ',' ComponentAttrSpecList ':' ':' ComponentDeclList
	O| {$$ = make (COMPONENT_DEF_STMT);}
	| TypeSpec ':'':' ComponentDeclList
	O| {$$ = make (COMPONENT_DEF_STMT);}
	| TypeSpec  ComponentDeclList
	O| {$$ = make (COMPONENT_DEF_STMT);}
	;

ComponentDeclList
	: ComponentDeclList ',' ComponentDecl
	O| {;}
	| ComponentDecl
	O| {;}
	;

ComponentAttrSpecList
	: ComponentAttrSpecList ',' ComponentAttrSpec
	O| {;}
	| ComponentAttrSpec
	O| {;}
	;

/* 427 */

ComponentAttrSpec
	: POINTER
	O| {;}
	| DIMENSION '(' SubscriptList ')'
	O| {;}
	;

/* 429 */

ComponentDecl
	: NAME '(' SubscriptList ')' '*' CharLength
	O| {;}
	| NAME
	O| {;}
	| NAME '(' SubscriptList ')'
	O| {;}
	| NAME '*' CharLength
	O| {;}
	;

/* 431 */

ArrayConstructor
	: LDAC AcValueList RDAC
	;

AcValueList
	: ImpliedValueList
	;

ImpliedValueList
	: ImpliedValueList ',' ImpliedValue
	| ImpliedValue
	;

/* 432 */

/*!!! Expr ':' ... are only allowed for array constructors */

ImpliedValue
	: Expr
	| ImpliedDo
	| Stride
	;

Stride:
	: Expr ':' Expr
	| Expr ':' Expr ':' Expr
	;

/* 433 */

ImpliedDo
	: LPEQI ImpliedValueList ',' ImpliedDoControl ')'
	;

/* 5: D A T A   O B J E C T   D E C L A R A T I O N S   A N D   S P E C I F I C A T I O N S */

OptComma
	: 
	| ','
	;

/* 501 */

TypeDeclarationStmt
	: TypeSpec ',' AttrSpecList ':' ':' EntityDecl1List
	| TypeSpec ':'':' EntityDecl1List
	| TypeSpec EntityDecl1List
	;

EntityDeclList
	: EntityDeclList ',' EntityDecl
	| EntityDecl
	;

EntityDecl1List
	: EntityDecl1List ',' EntityDecl1
	| EntityDecl1
	;

AttrSpecList
	: AttrSpecList ',' AttrSpec
	| AttrSpec
	;

/* 502 */
/* Check: dimension shouldn't be here */

TypeSpec
	: INTEGER OptKindSelector
	{
		$$ = parse_TypeSpec ($$, "INTEGER", TYP_INTEGER, 0);
	}
	| REAL OptKindSelector
	{
		$$ = parse_TypeSpec ($$, "REAL", TYP_REAL, 0);
	}
	| DOUBLE_PRECISION
	{
		$$ = parse_TypeSpec ($$, "DOUBLE PRECISION", TYP_REAL, 1);
	}
	| COMPLEX OptKindSelector
	{
		$$ = parse_TypeSpec ($$, "COMPLEX", TYP_COMPLEX, 0);
	}
	| DOUBLE_COMPLEX OptKindSelector
	{
		$$ = parse_TypeSpec ($$, "DOUBLE COMPLEX", TYP_COMPLEX, 1);
	}
	| CHARACTER
	{
		se_EtypeSpec = machine_etype (TYP_CHARACTER, 0);
	}
	| CHARACTER CharSelector
	{
		se_EtypeSpec = machine_etype (TYP_CHARACTER, 0);
	}
	| LOGICAL OptKindSelector
	{
		$$ = parse_TypeSpec ($$, "LOGICAL", TYP_LOGICAL, 0);
	}
	| TYPE '(' NAME ')'
	O|{
		f90ni_UDDTAO;
	}
	;

/* 503 */

AttrSpec
	: NAME
	{
		yacc_AttrSpec ($$);
	}
	| NAME '(' SubscriptList ')'
	{
		yacc_AttrSpec ($$);
	}
	;

/* 504 */

EntityDecl1
	: EntityDecl OptCharLength OptInitializationExpr
	;

EntityDecl
	: NAME opt7
	;

opt7
	:
	| '(' SubscriptList ')'
	;

OptCharLength
	:
	| '*' CharLength
	;

OptInitializationExpr
	:
	| '=' Expr
	;

/* 505 */

OptKindSelector
	: 
	| KindSelector
	;

KindSelector
	: '(' NAME '=' Expr ')'
	| '(' Expr ')'
	| '*' INTEGER_CONSTANT
	| LPEQI NAME '=' Expr ')'
	;

CharSelector
	: '(' NAME '=' Expr ',' NAME '=' Expr ')'
	{
		$$ = yacc_CharSelector_2 ($$);
	}
	| '(' NAME '=' Expr ')'
	{
		$$ = yacc_CharSelector_1 ($$);
	}
	| '*' CharLength
	| '*' CharLength CHAR_SELECTOR_COMMA
	| '(' Expr ')'
	| LPEQI NAME '=' Expr ',' NAME '=' Expr ')'
	{
		$$ = yacc_CharSelector_2 ($$);
	}
	| LPEQI NAME '=' Expr ')'
	{
		$$ = yacc_CharSelector_1 ($$);
	}
	;

/* 508 */

CharLength
	: '(' TypeParamValue ')'
	| LiteralConstant
	;

/* 509 */

TypeParamValue
	: Expr
	| '*'
	;

/* 510 */

AccessSpec
	: PUBLIC
	O| {;}
	| PRIVATE
	O| {;}
	;

/* 519 */

IntentStmt
	: INTENT '(' NAME ')' ':' ':' NameList
	{
		yacc_IntentStmt ($$);
	}
	| INTENT '(' NAME ')' NameList
	{
		yacc_IntentStmt ($$);
	}
	;

/* 520 */

OptionalStmt
	: OPTIONAL ':' ':' NameList
	;

/* 521 */

AccessStmt
	: AccessSpec OptCC NameList
	O| {$$ = make (ACCESS_STMT);}
	| AccessSpec
	O| {$$ = make (ACCESS_STMT);}
	;


OptCC
	: 
	| ':' ':'
	;

/* 522 */

SaveStmt
	: SAVE OptCC SavedEntityList
	{
		$$->SaveStmt.OptCC = NN;
	}
	| SAVE
	;

SavedEntityList
	: SavedEntityList ',' SavedEntity
	| SavedEntity
	;

/* 523 */

SavedEntity
	: '/' NAME '/'
	| NAME
	;

/* 524 */

DimensionStmt
	: DIMENSION
	{
		se_DimensionStmt_in = 1;
	}
	  EntityDeclList
	;

/* 525 */

AllocatableStmt
	: ALLOCATABLE OptCC EntityAllocatableList
	O| {$$ = make (ALLOCATABLE_STMT);}
	;

EntityAllocatableList
	: EntityAllocatableList ',' EntityAllocatable
	O| {;}
	| EntityAllocatable
	O| {;}
	;


EntityAllocatable
	: NAME '(' SubscriptList ')'
	O| {;}
	| NAME
	O| {;}
	;

/* 526 */

PointerStmt
	: POINTER OptCC EntityAllocatableList
	O| {$$ = make (POINTER_STMT);}
	;

/* 527 */

TargetStmt
	: KTARGET OptCC EntityTargetList
	O| {$$ = make (TARGET_STMT);}
	;

EntityTargetList
	: EntityTargetList ',' EntityTarget
	O| {;}
	| EntityTarget
	O| {;}
	;


EntityTarget
	: NAME '(' SubscriptList ')'
	O| {;}
	| NAME
	O| {;}
	;

/* 528 */

DataStmt
	: DATA DataStmtSetList
	;

DataStmtSetList
	: DataStmtSetList ',' DataStmtSet
	| DataStmtSetList DataStmtSet
	| DataStmtSet
	;

/* 529 */

DataStmtSet
	: DataStmtObjectList '/' DataStmtValueList '/'
	;

DataStmtObjectList
	: DataStmtObjectList ',' DataStmtObject
	| DataStmtObject
	;

DataStmtValueList
	: DataStmtValueList ',' DataStmtValue
	| DataStmtValue
	;

/* 530 */

DataStmtObject
	: Variable
	| DataImpliedDo
	;

/* 531 */

DataStmtValue
	: DataStmtRepeat '*' DataStmtConstant
	| DataStmtConstant
	;

/* 532 */

DataStmtConstant
	: AddOp DataStmtRepeat
	| DataStmtRepeat
	| ArraySection /* for StructureConstructor */
	;

/* 533 */

DataStmtRepeat
	: NAME
	| LiteralConstant
	;

/* 534 */

DataImpliedDo
	: ImpliedDo
	;

/* R01 */

ImpliedDoControl
	: NAME '=' Expr ',' Expr ',' Expr
	| NAME '=' Expr ',' Expr
	;

/* 537 */

ParameterStmt
	: PARAMETER '(' NamedConstantDefList ')'
	| PARAMETER LPEQI NamedConstantDefList ')'
	{
		$$->ParameterStmt.Lp = &Lp;
		$$->ParameterStmt.Lpeqi = NN;
	}
	;

NamedConstantDefList
	: NamedConstantDefList ',' NamedConstantDef
	| NamedConstantDef
	;

/* 538 */

NamedConstantDef
	: NAME '=' Expr
	;

/* 539 */

ImplicitStmt
	: IMPLICIT ImplicitSpecList
	;

ImplicitNoneStmt
	: IMPLICIT NAME
	O|{
		key_check ($2, "NONE");

		implicit_set_none ();
		$$ = &IgnoreStmt;
	}
	;

ImplicitSpecList
	: ImplicitSpecList ',' ImplicitSpec
	| ImplicitSpec
	;

/* 540 */

ImplicitSpec
	: TypeSpec LPIMP LetterSpecList ')'
	;

LetterSpecList
	: LetterSpecList ',' LetterSpec
	| LetterSpec
	;

/* 541 */

LetterSpec
	: Letter '-' Letter
	{
		implicit_set ($1->com.str[0], $3->com.str[0], se_EtypeSpec);
	}
	| Letter
	{
		implicit_set ($1->com.str[0], $1->com.str[0], se_EtypeSpec);
	}
	;


Letter
	: NAME
	{
		if (strlen ($1->com.str) != 1)
			yyerror ("syntax error");
	}
	;

/* 542. There should be an optional comma */

NamelistStmt
	: NAMELIST '/' NAME '/' NameList
	| NamelistStmt '/' NAME '/' NameList
	;

/* 544 */

EquivalenceStmt
	: EQUIVALENCE EquivalenceSetList
	;

EquivalenceSetList
	: EquivalenceSetList ',' EquivalenceSet
	| EquivalenceSet
	;

/* 545 */

EquivalenceSet
	: '(' EquivalenceObjectList ')'
	;

EquivalenceObjectList
	: EquivalenceObjectList ',' EquivalenceObject
	| EquivalenceObject
	;

/* 546 */

EquivalenceObject
	: NAME
	| ArraySection  /* for Substring and ArrayElement */
	;

/* 547 */

CommonStmt
	: CommonStmt1
	| CommonStmt ',' CommonBlock EntityDecl
	| CommonStmt CommonBlock EntityDecl
	| CommonStmt ',' EntityDecl
	;

CommonStmt1
	: COMMON
	{
		se_CommonStmt_in = 1;
	}
	  CommonBlock EntityDecl
	| COMMON
	{
		se_CommonStmt_in = 1;
	}
	  EntityDecl
	;

CommonBlock
	: CONCAT_OP
	{
		se_CommonStmt_blank = 1;
	}
	| '/' NAME '/'
	{
		T_Entry *entry;

		if (lookup_glo ($2->com.str) == TN) {
			entry = install_glo ($2->com.str, TAB_NAME, 0);
			SET_common (entry);
		}

		se_CommonStmt_blank = 0;
	}
	;

/* 548. CommonBlockObject catched by EntityDecl */

/* 6: U S E   O F   D A T A   O B J E T S */
/* 601 */

Variable [
N|
]
	: NAME
	| ArraySection  /* ArrayElement and Substring included here */
	O|{
		$$ = $1;
	}
	| StructureComponent
	O|{
		f90ni_uddtao ();
	}
	;

/* 607, 608. Substring catched by ArraySection */
/* 610 */

StructureComponent
	: ParentStructure '%' NAME
	O|{
		;
	}
	;

/* 611 */

ParentStructure
	: NAME
	| ArraySection  /* ArrayElement included here */
	| StructureComponent
	O|{
		;
	}
	;

/* 612. ArrayElement included in ArraySection */
/* 613 */

ArraySection
	: NAME '(' SubscriptList ')'
	| NAME '(' Org_SubscriptList   /*BOZKUS*/
	| NAME LPEQI SubscriptList ')'
	{
		$$->ArraySection.Lp = &Lp;
		$$->ArraySection.Lpeqi = NN;
	}
	| ArraySection '(' SubscriptList ')'
	| StructureComponent '(' SubscriptList ')'
	O| {;}
	| CHARACTER_CONSTANT '(' SubscriptList ')'
	| NAME '(' ')'
	;

Org_SubscriptList
	: Org_SubscriptList ',' Subscript
	| Subscript
	;

SubscriptList
	: SubscriptList ',' Subscript
	| Subscript
	;

/* 616. Catch all */

Subscript
	: Expr ':' Expr ':' Expr
	| Expr
	| '*'
	| Expr ':' '*'
	| ':'
	| Expr ':'
	| ':' Expr      
	O|{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Colon = &Colon;
		$$->Subscript.Expr1 = $2;
	}
	| ':' ':' Expr
	O|{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Colon = &Colon;
		$$->Subscript.Colon1 = &Colon;
		$$->Subscript.Expr2 = $3;
	}
	| Expr ':' Expr
	| Expr ':' ':' Expr
	O|{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Expr = $1;
		$$->Subscript.Colon = &Colon;
		$$->Subscript.Colon1 = &Colon;
		$$->Subscript.Expr2 = $4;
	}
	| ':' Expr ':' Expr
	O|{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Colon = &Colon;
		$$->Subscript.Expr1 = $2;
		$$->Subscript.Colon1 = &Colon;
		$$->Subscript.Expr2 = $4;
	}
	| NAME '=' Expr
	| '*' Label
	;

/* 620 */

AllocateStmt
	: ALLOCATE '(' AllocationList ',' NAME '=' Variable ')'
	O| {$$ = make (ALLOCATE_STMT);}
	| ALLOCATE LPEQI AllocationList ',' NAME '=' Variable ')'
	O| {$$ = make (ALLOCATE_STMT);}
	| ALLOCATE '(' AllocationList ')'
	O| {$$ = make (ALLOCATE_STMT);}
	;

AllocationList
	: AllocationList ',' Allocation
	O| {;}
	| Allocation
	O| {;}
	;


/* 622 */

Allocation
	: ArraySection
	O| {;}
	| NAME
	O| {;}
	| StructureComponent
	O| {;}
	;

/* 623 */

AllocateObject
	: NAME
	O| {;}
	| StructureComponent
	O| {;}
	;

/* 624 */

NullifyStmt
	: NULLIFY '(' NameList ')'
	O| {$$ = make (NULLIFY_STMT);}
	;

/* 625 */

DeallocateStmt
	: DEALLOCATE '(' AllocateObjectList ',' NAME '=' Variable ')'
	O| {$$ = make (DEALLOCATE_STMT);}
	| DEALLOCATE LPEQI AllocateObjectList ',' NAME '=' Variable ')'
	O| {$$ = make (DEALLOCATE_STMT);}
	| DEALLOCATE '(' AllocateObjectList ')'
	O| {$$ = make (DEALLOCATE_STMT);}
	;

AllocateObjectList
	: AllocateObjectList ',' AllocateObject
	O| {;}
	| AllocateObject
	O| {;}
	;

/* 7: E X P R E S S I O N S   A N D   A S S I G N M E N T */
/* 701 */

Primary
	: LiteralConstant
	O|{
		$$ = $1;
	}
	| Variable
	O|{
		$$ = $1;
	}
	| ArrayConstructor
	O|{
		$$ = $1;
	}
	| '(' Expr ')'
	| LPEQI Expr ')'
	{
		$$->Primary.Lp = &Lp;
		$$->Primary.Lpeqi = NN;
	}
	;

/* 703 */

Level1Expr
	: DEFINED_UNARY_OP Primary
	O|{
		f90ni_uddtao ();
	}
	| Primary
	O|{
		$$ = $1;
	}
	| AddOp Primary   /* to allow i = i * - 3 */
	O|{
		$$ = make_DumExpr (NN, $1, $2);
	}
	;

/* 705 */

MultOperand
	: Level1Expr POWER_OP MultOperand
	O|{
		$$ = make_DumExpr ($1, &PowerOp, $3);
	}
	| Level1Expr
	O|{
		$$ = $1;
	}
	;

/* 706 */

AddOperand
	: AddOperand MultOp MultOperand
	O|{
		$$ = make_DumExpr ($1, $2, $3);
	}
	| MultOperand
	O|{
		$$ = $1;
	}
	;

/* 707 */

Level2Expr
	: Level2Expr AddOp AddOperand
	O|{
		$$ = make_DumExpr ($1, $2, $3);
	}
	| AddOp AddOperand
	O|{
		$$ = make_DumExpr (NN, $1, $2);
	}
	| AddOperand
	O|{
		$$ = $1;
	}
	;

/* 709 */

MultOp
	: '*'
	| '/'
	;

/* 710 */

AddOp
	: '+'
	| '-'
	;

/* 711 */

Level3Expr
	: Level3Expr CONCAT_OP Level2Expr
	O|{
		$$ = make_DumExpr ($1, &ConcatOp, $3);
	}
	| Level2Expr
	O|{
		$$ = $1;
	}
	;

/* 713 */

Level4Expr
	: Level3Expr RelOp Level3Expr
	O|{
		$$ = make_DumExpr ($1, $2, $3);
	}
	| Level3Expr
	O|{
		$$ = $1;
	}
	;

/* 714 */

RelOp
	: REL_OP_EQ
	| REL_OP_NE
	| REL_OP_LT
	| REL_OP_LE
	| REL_OP_GT
	| REL_OP_GE
	;

/* 715 */

AndOperand
	: NOT_OP Level4Expr
	O|{
		$$ = make_DumExpr (NN, &NotOp, $2);
	}
	| Level4Expr
	O|{
		$$ = $1;
	}
	;

/* 716 */

OrOperand
	: OrOperand AND_OP AndOperand
	O|{
		$$ = make_DumExpr ($1, &AndOp, $3);
	}
	| AndOperand
	O|{
		$$ = $1;
	}
	;

/* 717 */

EquivOperand
	: EquivOperand OR_OP OrOperand
	O|{
		$$ = make_DumExpr ($1, &OrOp, $3);
	}
	| EquivOperand XOR_OP OrOperand
	O|{
		$$ = make_DumExpr ($1, &XorOp, $3);
	}
	| OrOperand
	O|{
		$$ = $1;
	}
	;

/* 718 */

Level5Expr
	: Level5Expr EquivOp EquivOperand
	O|{
		$$ = make_DumExpr ($1, $2, $3);
	}
	| EquivOperand
	O|{
		$$ = $1;
	}
	;

/* 722 */

EquivOp
	: EQUIV_OP_T
	| EQUIV_OP_F
	;

/* 723 */

Expr
	: Expr DEFINED_UNARY_OP Level5Expr
	O|{
		$$ = make_DumExpr ($1, &DefinedUnaryOp, $3);
	}
	| Level5Expr
	O|{
		$$ = $1;
	}
	;

/* 737 */

AssignementStmt
	: Variable '=' Expr
	;

/* 738 */

PointerAssignementStmt
	: NAME POINT_OP Target
	O| {$$ = make (POINTER_ASSIGNEMENT_STMT);}
	;


Target
	: ArraySection
	O| {;}
	| NAME
	O| {;}
	| StructureComponent
	O| {;}
	;

/* 740 */

WhereStmt
	: WHERE '(' Expr ')' AssignementStmt
	| WHERE LPEQI Expr ')' AssignementStmt
	{
		$$->WhereStmt.Lp = &Lp;
		$$->WhereStmt.Lpeqi = NN;
	}
	;

/* 742 */

WhereConstructStmt
	: WHERE '(' Expr ')'
	| WHERE LPEQI Expr ')'
	{
		$$->WhereConstructStmt.Lp = &Lp;
		$$->WhereConstructStmt.Lpeqi = NN;
	}
	;

/* 744 */

ElsewhereStmt [
N|
]
	: ELSE_WHERE
	;

/* 745 */

EndWhereStmt [
N|
]
	: END_WHERE
	;

/* 8: E X E C U T I O N   C O N T R O L */
/* 803 */

IfThenStmt
	: IF '(' Expr ')' NAME
	{
		key_check ($5, "THEN");
	}
	| NAME ':' IF '(' Expr ')' NAME
	{
		key_check ($7, "THEN");
	}
	| IF LPEQI Expr ')' NAME
	{
		key_check ($5, "THEN");

		$$->IfThenStmt.Lpeqi = NN;
		$$->IfThenStmt.Lp = &Lp;
	}
	| NAME ':' IF LPEQI Expr ')' NAME
	{
		key_check ($7, "THEN");

		$$->IfThenStmt.Lpeqi = NN;
		$$->IfThenStmt.Lp = &Lp;
	}
	;

/* 804 */

ElseIfStmt
	: ELSE_IF '(' Expr ')' NAME NAME
	{
		key_check ($5, "THEN");
	}
	| ELSE_IF '(' Expr ')' NAME
	{
		char *name;

		if ((name = key_check ($5, "THEN")) != CN)
			$$->ElseIfStmt.Name1 = make_Name (name);
	}
	| ELSE_IF LPEQI Expr ')' NAME NAME
	{
		key_check ($5, "THEN");

		$$->ElseIfStmt.Lpeqi = NN;
		$$->ElseIfStmt.Lp = &Lp;
	}
	| ELSE_IF LPEQI Expr ')' NAME
	{
		char *name;

		if ((name = key_check ($5, "THEN")) != CN)
			$$->ElseIfStmt.Name1 = make_Name (name);

		$$->ElseIfStmt.Lpeqi = NN;
		$$->ElseIfStmt.Lp = &Lp;
	}
	;

/* 805 */

ElseStmt
	: ELSE NAME
	| ELSE
	;

/* 806 */

EndIfStmt
	: END_IF NAME
	| END_IF
	;

/* 807 */

IfStmt
	: IF '(' Expr ')' Stmt
	| IF LPEQI Expr ')' Stmt
	{
		$$->IfStmt.Lpeqi = NN;
		$$->IfStmt.Lp = &Lp;
	}
	;

/* 809 */

SelectCaseStmt
	: SELECT NAME '(' Expr ')'
	{
		key_check ($2, "CASE");
	}
	| NAME ':' SELECT NAME '(' Expr ')'
	{
		key_check ($4, "CASE");
	}
	;

/* 810 */

CaseStmt
	: CASE CaseSelector NAME
	| CASE CaseSelector
	{
		char *name;

		if ($2->CaseSelector.Name != NN
		&&  (name = key_check ($2->CaseSelector.Name, "DEFAULT")) != CN)
			$$->CaseStmt.Name = make_Name (name);
	}
	;

/* 811 */

EndSelectStmt
	: END_SELECT NAME
	| END_SELECT
	;

/* 813 */

CaseSelector
	: '(' SubscriptList ')'
	| NAME
	;

/* 818 */

DoStmt
	: NAME ':' DO OptLabel LoopControl
	| DO OptLabel LoopControl
	;


OptLabel
	: 
	| Label
	;

/* 821 */

LoopControl
	: 
	| OptComma ImpliedDoControl
	| OptComma NAME '(' Expr ')'
	{
		key_check ($2, "WHILE");
	}
	| OptComma NAME LPEQI Expr ')'
	{
		key_check ($2, "WHILE");

		$$->LoopControl.Lpeqi = NN;
		$$->LoopControl.Lp = &Lp;
	}
	| '(' Expr ')' NAME
	{
		key_check ($4, "TIMES");  /*!!! replace by found NAME, expecting "TIMES" */
	}
	| LPEQI Expr ')' NAME
	{
		key_check ($4, "TIMES");

		$$->LoopControl.Lpeqi = NN;
		$$->LoopControl.Lp = &Lp;
	}
	;

/* 824 */

EndDoStmt
	: END_DO NAME
	| END_DO
	;

/* 834 */

CycleStmt [
A| union Node *label;
]
	: CYCLE NAME
	| CYCLE
	;

/* 835 */

ExitStmt [
A| union Node *label;
]
	: EXIT NAME
	| EXIT
	;

/* 836 */

GotoStmt
	: GO_TO Label
	;

/* 837 */

ComputedGotoStmt
	: GO_TO '(' LabelList ')' OptComma Expr
	;

LabelList
	: LabelList ',' Label
	| Label
	;

Label
	: INTEGER_CONSTANT
	{
		label_install_ref ($1);
	}
	;

/* 838 */

AssignStmt
	: ASSIGN Label TO Variable
	;

/* 839 */

AssignedGotoStmt
	: GO_TO NAME OptComma '(' LabelList ')'
	| GO_TO NAME
	;

/* 840 */

ArithmeticIfStmt
	: IF '(' Expr ')' Label ',' Label ',' Label
	| IF LPEQI Expr ')' Label ',' Label ',' Label
	{
		$$->ArithmeticIfStmt.Lpeqi = NN;
		$$->ArithmeticIfStmt.Lp = &Lp;
	}
	;

/* 841 */

ContinueStmt [
N|
]
	: CONTINUE
	;

/* 842 */

StopStmt
	: STOP StopCode
	| STOP
	;

/* 843 */

StopCode
	: CHARACTER_CONSTANT
	| INTEGER_CONSTANT
	;

/* 844 */

PauseStmt
	: PAUSE StopCode
	| PAUSE
	;

/* R160 */

ForallStmt [
A| union Node *statement, *var, *upd;
]
	: FORALL '(' ForallTripletSpecList OptScalarMaskExpr ')' Stmt
	{
		stand ("FORALL statement");
	}
	| FORALL LPEQI ForallTripletSpecList OptScalarMaskExpr ')' Stmt
	{
		stand ("FORALL statement");

		$$->ForallStmt.Lp = &Lp;
		$$->ForallStmt.Lpeqi = NN;
	}
	;

OptScalarMaskExpr
	:
	| ',' Expr
	;

ForallTripletSpecList
	: ForallTripletSpecList ',' ForallTripletSpec
	| ForallTripletSpec
	;

/* R161 */

ForallTripletSpec
	: NAME '=' Expr ':' Expr
	| NAME '=' Expr ':' Expr ':' Expr
	;

/* 9: I N P U T / O U T P U T   S T A T E M E N T S */
/* 904 */

OpenStmt [
A| struct Unit *unit;
]
	: OPEN '(' IoSpecList ')'
	| OPEN LPEQI IoSpecList ')'
	{
		$$->OpenStmt.Lp = &Lp;
		$$->OpenStmt.Lpeqi = NN;
	}
	;

IoSpecList
	: IoSpecList ',' IoSpec
	| IoSpec
	;

/* 905 */

IoSpec
	: NAME '=' Expr
	| NAME '=' '*'
	| Expr
	| '*'
	;

/* 907 */

CloseStmt [
A| struct Unit *unit;
]
	: CLOSE '(' IoSpecList ')'
	| CLOSE LPEQI IoSpecList ')'
	{
		$$->CloseStmt.Lp = &Lp;
		$$->CloseStmt.Lpeqi = NN;
	}
	;

/* 909 */

ReadStmt [
A| struct Unit *unit;
]
	: READ FormatSpec
	| READ '(' IoSpecList ')'
	| READ LPEQI IoSpecList ')'
	| READ FormatSpec ',' InputItemList
	| READ '(' IoSpecList ')' InputItemList
	| READ LPEQI IoSpecList ')' InputItemList
	;

FormatSpec
	: FormatExpr
	| INTEGER_CONSTANT
	| '*'
	;

FormatExpr
	: CHARACTER_CONSTANT
	O|{
		$$ = $1;
	}
	| Variable
	O|{
		$$ = $1;
	}
	| FormatExpr CONCAT_OP CHARACTER_CONSTANT
	O|{
		$$ = make_DumExpr ($1, &ConcatOp, $3);
	}
	| FormatExpr CONCAT_OP Variable
	O|{
		$$ = make_DumExpr ($1, &ConcatOp, $3);
	}
	;

InputItemList	
	: ImpliedValueList
	;

/* 910 */

WriteStmt [
A| struct Unit *unit;
]
	: WRITE '(' IoSpecList ')'
	| WRITE LPEQI IoSpecList ')'
	| WRITE '(' IoSpecList ')' OutputItemList
	| WRITE LPEQI IoSpecList ')' OutputItemList
	;

OutputItemList
	: ImpliedValueList
	;

/* 911 */

PrintStmt [
A| struct Unit *unit;
]
	: PRINT FormatSpec
	| PRINT FormatSpec ',' OutputItemList
	;

/* 919 */

BackspaceStmt [
A| struct Unit *unit;
]
	: BACKSPACE Expr
	| BACKSPACE LPEQI IoSpecList ')'
	;

/* 920 */

EndFileStmt [
A| struct Unit *unit;
]
	: END_FILE Expr
	| END_FILE LPEQI IoSpecList ')'
	;

/* 921 */

RewindStmt [
A| struct Unit *unit;
]
	: REWIND Expr
	| REWIND LPEQI IoSpecList ')'
	;

/* 923 */

InquireStmt [
A| struct Unit *unit;
]
	: INQUIRE '(' IoSpecList ')'
	| INQUIRE LPEQI IoSpecList ')'
	;

/* 10: I N P U T / O U T P U T   E D I T I N G */
/* 1001 */
/* Check: for the moment just skip up to the end of statement */

FormatStmt [
N|
]
	: FORMAT
	;

/* 11: P R O G R A M   U N I T S */
/* 1102 */

ProgramStmt
	: KPROGRAM NAME
	{
		install_glo ($2->com.str, TAB_NAME, 0);
	}
	;

/* 1103 */

EndProgramStmt
	: END_PROGRAM NAME
	| END_PROGRAM
	;


EndStmt [
N|
]
	: END
	;

/* 1105 */

ModuleStmt
	: MODULE NAME
	;

/* 1106 */

EndModuleStmt
	: END_MODULE NAME
	| END_MODULE
	;

/* 1107 */

UseStmt
	: USE NAME
	| USE NAME ',' RenameList
	| USE NAME ',' NAME ':' OnlyList
	;

RenameList
	: RenameList ',' Rename
	| Rename
	;

Rename
	: NAME POINT_OP NAME
	;

OnlyList
	: OnlyList ',' Only
	| Only
	;

Only
	: GenericSpec
	| Rename
	;

/* 1111 */

BlockDataStmt
	: BLOCK_DATA NAME
	| BLOCK_DATA
	;

/* 1112 */

EndBlockDataStmt
	: END_BLOCK_DATA NAME
	| END_BLOCK_DATA
	;

/* 12: P R O C E D U R E S */
/* 1202 */

InterfaceStmt
	: INTERFACE GenericSpec
	O|{
		$$ = &IgnoreStmt;

		if (se_in_interface) {
			warning (
			"INTERFACE within INTERFACE, all but the type of the procedure ignored");
			se_interfaces_within_interfaces++;
		}
		else {
			se_in_interface = 1;
			push_scope ();
			state_level++;
			over_begin ($2);
		}
	}
	;

/* 1203 */

EndInterfaceStmt [
N|
]
	: END_INTERFACE
	O|{
		if (se_interfaces_within_interfaces) {
			$$ = &EndInterface;

			goto skip_rest_EndInterface;
		}

		$$ = &IgnoreStmt;

		if (state [state_level] != UNIT_OUT) {
			warning ("missing END statement");
			order_enddecl_parse ();

			order_reset_states ();

			current_pass = PASS_WRITE;
			proc_end_before_write ();
			proc_end_after_write ();
			current_pass = PASS_PARSE;
		}

		if (se_in_interface) {
			se_in_interface = 0;
			over_end ();
			pop_scope ();
			state_level--;
		}
		else
			fatal ("END INTERFACE statement not in INTERFACE body");

		skip_rest_EndInterface:;
	}
	;

/* 1205 */

ModuleProcedureStmt
	: MODULE NAME NameList
	{
		key_check ($2, "PROCEDURE");
	}
	;

/* 1206 */

GenericSpec
	:
	| NAME
	| NAME '(' DefinedOperator ')'
	{
		key_check ($1, "OPERATOR");
	}
	| NAME '(' '=' ')'
	{
		key_check ($1, "ASSIGNMENT");
	}
	| NAME LPEQI '=' ')'
	{
		key_check ($1, "ASSIGNMENT");

		$$->GenericSpec.Lpeqi = NN;
		$$->GenericSpec.Lp = &Lp;
	}
	;

/* 1207 */

ExternalStmt
	: EXTERNAL NameList
	;

NameList
	: NameList ',' NAME
	| NAME
	;

/* 1208 */

IntrinsicStmt
	: INTRINSIC NameList
	;

/* 1209 */
/* FunctionReference is catched by ArrayElement. */

/* 1210 */

CallStmt
	: CALL NAME '(' SubscriptList ')'
	{
		$4 = $$->CallStmt.SubscriptList = list_invert ($4);
	}
	| CALL NAME LPEQI SubscriptList ')'
	{
		$4 = $$->CallStmt.SubscriptList = list_invert ($4);
		$$->CallStmt.Lp = &Lp;
		$$->CallStmt.Lpeqi = NN;
	}
	| CALL NAME '(' ')'
	| CALL NAME
	;

/* 1216 */

FunctionStmt
	: opt31 FUNCTION NAME '(' OptNameList ')' opt33
	| opt31 FUNCTION NAME  /*!!! CMF accepts it */
	{
		warning ("missing parenthesis in FUNCTION statement");
	}
	;

opt31
	:
	| Prefix
	;

OptNameList
	:
	| NameList
	;

opt33
	:
	| NAME '(' NAME ')'
	;

/* 1217 */

Prefix
	: TypeSpec RECURSIVE
	{
		f90ni_recursive ();
	}
	| TypeSpec
	| RECURSIVE TypeSpec
	{
		f90ni_recursive ();
	}
	| RECURSIVE
	{
		f90ni_recursive ();
	}
	;

/* 1218 */

EndFunctionStmt
	: END_FUNCTION NAME
	| END_FUNCTION
	;

/* 1220 */

SubroutineStmt
	: OptRecursive SUBROUTINE NAME '(' OptDummyArgList ')'
	| OptRecursive SUBROUTINE NAME
	;

OptDummyArgList
	:
	| DummyArgList
	;

DummyArgList
	: DummyArgList ',' DummyArg
	| DummyArg
	;


OptRecursive
	: 
	| RECURSIVE
	O|{
		f90ni_recursive ();
	}
	;

/* 1221 */

DummyArg
	: NAME
	| '*'
	;

/* 1222 */

EndSubroutineStmt
	: END_SUBROUTINE NAME
	| END_SUBROUTINE
	;

/* 1223 */

EntryStmt
	: ENTRY NAME '(' DummyArgList ')'
	| ENTRY NAME '(' ')'
	| ENTRY NAME
	;

/* 1224 */

ReturnStmt
	: RETURN Expr
	| RETURN
	;

/* 1225 */

ContainsStmt [
N|
]
	: CONTAINS
	O| {$$ = make (CONTAINS_STMT);}
	;

/* 1229 */
/* Clashes whith array asignement. Needs to be done by hand.
StmtFunctionStmt
	: NAME DummyArgs '=' Expr
	;
*/

/*************************** D U M M Y S ***********************************/

DumArrCons [
N|
NP|
A| struct ArrCons *ac;
]
	: Expr
	;

DumExpr [
NP|
]
	: '(' Expr OP Expr ')'
	;

DumStmt [
N|
NP|
A| union Node* Stmt;
]
	: CODE
	;

DumList [
N|
NP|
A| int num; union Node **list;
]
	:
	;

StmtFunctionStmt [
NP|
]
	: Variable '=' Expr
	;

FunctionReference [
NP|
A| struct T_Entry *entry; union Node *temp;
]
	: NAME '(' SubscriptList ')'
	;

Block [
NP|
]
	: Block ',' Statement
	| Statement
	;

WhereConstruct [
NP|
A| union Node *label, *label_endwhere; int line; char *file;
]
	: WhereConstructStmt
	  WhereBlock 
	  ElsewhereStmt
	  ElsewhereBlock
      EndWhereStmt
	;

CaseConstruct [
NP|
A| union Node *label, *label_endselect; int line; char *file;
]
	: SelectCaseStmt
	  CaseStmtBlockList
	  EndSelectStmt
	;

IfConstruct [
NP|
A| union Node *label, *label_endif; int line; char *file;
]
	: IfThenStmt
	  IfBlock
	  ElseIfStmtBlockList
	  ElseStmt
	  ElseBlock
	  EndIfStmt
	;

DoConstruct [
NP|
A| int do_type; union Node *label, *label_enddo, *label_do, *label_cycle, *label_exit, *exit_list, *cycle_list, *do_times_var; int line; char *file;
]
	: DoStmt
	  DoBlock
	  EndDoStmt
	;

CaseStmtBlockList [
NP|
]
	: CaseStmtBlockList ',' CaseStmtBlock
	| CaseStmtBlock
	;

CaseStmtBlock [
NP|
]
	: CaseStmt CaseBlock
	;

ElseIfStmtBlockList [
NP|
]
	: ElseIfStmtBlockList ','  ElseIfStmtBlock
	| ElseIfStmtBlock
	;

ElseIfStmtBlock [
NP|
]
	: ElseIfStmt ElseIfBlock
	;
	
ProgramUnit [
NP|
]
	: SpecificationPartBlock
	  ExecutionPartBlock
	;
